<?php
/*****************************************************************************************************************************
* Mise à jour gérée directement par l'administrateur (un lien dans son menu pointant vers "admin_maj.php" *
*****************************************************************************************************************************/

$install->afficher("Base de données... ");

//fichier original servant à installer la base
$sqlFile = ABSPATH."tables.my.sql";

//requêtes lues dans le fichier 'tables.my.sql'
function install_tables($sqlFile)
	{
	global $install;

	//méthode de lecture du fichier des requêtes à effectuer reprise de celle utilisée par Webcalendar pour son fichier de connexion
	$grr_file = file_get_contents($sqlFile);
	$grr_file = preg_replace("/[\r\n]+/","\n",$grr_file);
	$grr_content = explode("\n",$grr_file);
	for($n=0; $n<count($grr_content); $n++)
		{
		$query = $grr_content[$n];
		$query = trim($query,"\r\n ");
		//par précaution, on n'exécute pas les suppression de tables car inutile et en plus il ne faudrait pas réinstaller une base déjà présente...
		if(!empty($query) && !preg_match("/drop table/i",$query)) $install->query($query,DB_NAME);
		}

	$nom_etab = $install->escape(LIBELLE_ETAB);
	$url_etab = $install->escape("https://".WEB_URL."/grr/");
	$domaine = $install->escape(DOMAINE_MESSAGERIE_ETAB);

	$install->query("UPDATE `grr_setting` SET VALUE='".$nom_etab."' WHERE NAME='company';",DB_NAME);
	$install->query("UPDATE `grr_setting` SET VALUE='admin@".$domaine."' WHERE NAME='webmaster_email';",DB_NAME);
	$install->query("UPDATE `grr_setting` SET VALUE='support.technique@".$domaine."' WHERE NAME='technical_support_email';",DB_NAME);
	$install->query("UPDATE `grr_setting` SET VALUE='".$url_etab."' WHERE NAME='grr_url';",DB_NAME);
	$install->query("INSERT INTO `grr_setting` (`NAME`,`VALUE`) VALUES ('sso_statut','cas_envole');",DB_NAME);
	//$install->query("INSERT INTO `grr_setting` (`NAME`,`VALUE`) VALUES ('envole_statut_prof','utilisateur');",DB_NAME);
	//$install->query("INSERT INTO `grr_setting` (`NAME`,`VALUE`) VALUES ('envole_statut_eleve','visiteur');",DB_NAME);
	}

//pour insérer un paramètre absent de la table grr_setting
function check_setting($name,$value)
	{
	global $install;
	
	$name = $install->escape($name);
	$value = $install->escape($value);
	
	$install->setRows("SELECT `VALUE` FROM `grr_setting` WHERE `NAME`='".$name."';",DB_NAME);
	if(count($install->rows)===0) $install->query("INSERT INTO `grr_setting` (`NAME`,`VALUE`) VALUES ('".$name."','".$value."');",DB_NAME);	
	}

$test = "SHOW TABLES";
$install->setRows($test,DB_NAME);
if(count($install->rows)===0)
	{
	if(!is_file($sqlFile)) $install->echec("Erreur > Fichier SQL \"".$sqlFile."\" servant à créer la base non présent\n\n");
	
	$install->afficher("installation des tables... ");
	install_tables($sqlFile);
	}
else
	{
	$install->afficher("tables présentes... ");	
	}

$install->afficher("vérification des paramètres... ");
//l'absence de "sso_status" se corrige manuellement en réactivant la connexion CAS par exemple
//renseigner "default_site" et "default_room" permet d'éviter les urls par défaut incomplètes du type "grr/week.php?area=1&room=" qui affiche un message "Accès refusé".
$liste_settings = array
	(
	"envole_statut_prof"          => "utilisateur",
	"envole_statut_eleve"         => "visiteur",
	"envole_statut_administratif" => "utilisateur",
	"envole_statut_responsable"   => "visiteur",
	"envole_statut_autre"         => "visiteur",
	"default_site"                => "-1",
	"default_room"                => "-1"
	);
foreach($liste_settings as $name=>$value) check_setting($name,$value);

$install->afficher("OK\n");
?>
